<template>
  <div class="app-container">
    <el-card>
      <!--      <span style="margin-left: 15px">班次类型:</span>-->
      <el-select v-model="dataTypeValue" placeholder="数据类型" clearable size="small" style="width:100px">
        <el-option
          v-for="item in dataType"
          :key="item.value"
          :label="item.label"
          :value="item.value"/>
      </el-select>
      <el-button type="primary" icon="el-icon-search" size="small" style="margin-left: 15px" plain @click="pageSize=20;pageCurrent=1;searchTable()">查询</el-button>
      <el-button type="distribution" icon="el-icon-circle-plus-outline" size="small" @click="addShiftTable('form')">新增</el-button>
      <el-button type="info" plain size="small" icon="el-icon-upload2" @click="importOrder('form')">导入</el-button>
      <el-table
        :data="tableData"
        border
        size="mini"
        height="750"
        center
        style="width: 100%">
        <el-table-column label="名称" align="center">
          <template slot-scope="scope">
            {{ scope.row.name }}
          </template>
        </el-table-column>
        <el-table-column label="序号" align="center">
          <template slot-scope="scope">
            {{ scope.row.value }}
          </template>
        </el-table-column>
        <el-table-column disabled label="数据类型" align="center">
          <template slot-scope="scope">
            {{ scope.row.type }}
          </template>
        </el-table-column>
        <el-table-column label="数据描述" align="center">
          <template slot-scope="scope">
            {{ scope.row.descript }}
          </template>
        </el-table-column>
        <el-table-column label="数据说明" align="center">
          <template slot-scope="scope">
            {{ scope.row.comments }}
          </template>
        </el-table-column>
        <el-table-column label="操作" width="200" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              plain
              icon="el-icon-edit"
              @click="editShiftTable(scope.row)">编辑</el-button>
            <el-button
              size="mini"
              type="text"
              plain
              icon="el-icon-delete"
              @click="handleDelete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin-top: 10px;">
        <el-pagination
          :current-page="pageCurrent"
          :page-sizes="[10, 20, 30, 40, 50]"
          :page-size="20"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>
    </el-card>
    <el-dialog :visible.sync="dialogFormVisible" :title="title" center style="min-height: 200px;" width="400px">
      <el-form ref="form" :model="form" :rules="rules" label-position="right" label-width="110px">
        <el-form-item label="数据类型" prop="dataTypeValue" style="display: inline-block">
          <el-select v-model="form.dataTypeValue" placeholder="数据类型" clearable size="small" style="width:200px">
            <el-option
              v-for="item in dataType"
              :key="item.value"
              :label="item.label"
              :value="item.value"/>
          </el-select>
        </el-form-item>
        <el-form-item label="数据名称" prop="name" style="display: inline-block">
          <el-input
            v-model="form.name"
            clearable
            size="small"
            placeholder="数据名称"/>
        </el-form-item><el-form-item label="序号" prop="value" style="display: inline-block">
          <el-input v-model="form.value" clearable size="small" placeholder="序号"/>
        </el-form-item>
        <el-form-item label="数据描述" prop="descript" style="display: inline-block">
          <el-input
            v-model="form.descript"
            clearable
            size="small"
            placeholder="数据描述"/>
        </el-form-item>
        <el-form-item label="数据说明" prop="comments" style="display: inline-block">
          <el-input
            v-model="form.comments"
            clearable
            size="small"
            placeholder="数据说明"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button v-if="title === '增加'" type="primary" size="small" @click="submitAdd('form')">确定</el-button>
        <el-button v-if="title === '编辑'" type="primary" size="small" @click="submitAdd1('form')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible3" title="导入" center style="min-height: 200px" width="900px">
      <div class="app-container">
        <upload-excel-component style="margin-left: 15%" @on-selected-file="selected"/>
        <div style="margin-left: 395px">
          <span v-show="worksheet.length > 1" style="cursor: pointer;width: 50px;" @click="removeAll"><i class="el-icon-close"/></span>
          <el-upload :on-remove="handleRemove" :file-list="itemFile" style="width: 220px" action=""/>
        </div>
        <div v-if="worksheet.length !== 0" style="margin: 3px 0 0 395px">
          <el-button icon="el-icon-upload2" type="primary" size="small" @click="basicPartsToSQL">导入到数据库</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { sleep } from '../../../utils/tool'
import UploadExcelComponent from './UploadExcel.vue'
export default {
  name: 'UploadExcel',
  components: { UploadExcelComponent },
  data() {
    return {
      worksheet: [],
      itemFile: [],
      unSpecification: [],
      dataTypeValue: '',
      dataType: [
        { value: '动作流程', label: '动作流程' },
        { value: 'HMI', label: 'HMI' },
        { value: '电气元器件动作', label: '电气元器件动作' },
        { value: '工位号', label: '工位号' },
        { value: '工厂', label: '工厂' },
        { value: '工作中心', label: '工作中心' },
        { value: '配方号', label: '配方号' },
        { value: '机器型号', label: '机器型号' }],
      tableData: [],
      hour: '',
      minutes: '',
      seconds: '',
      dialogFormVisible: false,
      dialogFormVisible3: false,
      form: {
        name: '',
        value: '',
        descript: '',
        comments: '',
        ID: '',
        dataTypeValue: ''
      },
      rules: { // 表单验证规则
        dataTypeValue: [{ required: true, message: '请选择', trigger: 'change' }],
        name: [{ required: true, message: '请输入', trigger: 'blur' }]
      },
      title: '',
      pageCurrent: 1,
      pageSize: 20,
      total: 0
    }
  },
  created() {
    this.searchTable()
  },
  methods: {
    searchTable() {
      this.tableData = []
      let dataTypeValue_check
      this.dataTypeValue ? dataTypeValue_check = 1 : dataTypeValue_check = 0
      var param = []
      param[0] = ['type_ischeck', dataTypeValue_check]
      param[1] = ['type', this.dataTypeValue]
      param[2] = ['PageCurrent', this.pageCurrent]
      param[3] = ['PageSize', this.pageSize]
      param[4] = ['PageCount', '1111', 'int', '1']
      param[5] = ['ItemCount', '1111', 'int', '1']
      var Data = this.CreateData('11', 'Recipe_WorkBook_Query', param)
      this.ExecDatabase(Data).then(response => {
        console.log(response, 66)
        if (response.data.result.length !== 0) {
          this.tableData = response.data.result
        }
        this.total = parseInt(response.data.output[0].ItemCount)
        this.loading = false
        console.log(this.tableData, 'this.tableData')
      })
    },
    addShiftTable(formName) {
      if (this.$refs[formName] !== undefined) {
        this.$refs[formName].resetFields()
      }
      this.title = '增加'
      this.form.name = ''
      this.form.value = ''
      this.form.descript = ''
      this.form.comments = ''
      this.form.dataTypeValue = ''
      this.dialogFormVisible = true
    },
    submitAdd(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['name', this.form.name]
          param[1] = ['type', this.form.dataTypeValue]
          param[2] = ['value', this.form.value]
          param[3] = ['decript', this.form.descript]
          param[4] = ['comments', this.form.comments]
          var Data = this.CreateData('12', 'Recipe_WorkBook_Add', param)
          this.ExecDatabase(Data).then(response => {
            console.log(response)
            if (response.data[0].result === '1') {
              this.$message({
                message: '增加成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
            } else {
              this.$message.error('增加失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    editShiftTable(row) {
      if (this.$refs['form'] !== undefined) {
        this.$refs['form'].resetFields()
      }
      this.form.name = row.name
      this.form.value = row.value
      this.form.descript = row.descript
      this.form.comments = row.comments
      this.form.ID = row.id
      this.form.dataTypeValue = row.type
      this.title = '编辑'
      this.dialogFormVisible = true
    },
    submitAdd1() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['name', this.form.name]
          param[1] = ['type', this.form.dataTypeValue]
          param[2] = ['value', this.form.value]
          param[3] = ['decript', this.form.descript]
          param[4] = ['comments', this.form.comments]
          param[5] = ['id', this.form.ID]
          var Data = this.CreateData('12', 'Recipe_WorkBook_Update', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '修改成功',
                type: 'success'
              })
              this.searchTable()
            } else {
              this.$message.error('修改失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    handleDelete(row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        var param = []
        param[0] = ['id', row.id]
        var Data = this.CreateData('12', 'Recipe_WorkBook_Delete', param)
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result === '1') {
            this.$message({
              message: '删除成功',
              type: 'success'
            })
            this.searchTable()
          } else {
            this.$message.error('删除失败！')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    callOff() {
      this.dialogFormVisible = false
    },
    importOrder() {
      this.dialogFormVisible3 = true
    },
    removeAll() {
      this.worksheet = []
      this.itemFile = []
    },
    async selected(data) { // 选择需要导入的文件
      console.log(data, 1111)
      this.worksheet = data.worksheet // 获取每个多选文件的表格坐标及值
      this.itemFile = data.itemFile
    },
    handleRemove(file) { // 移除文件
      for (let i = 0; i < this.itemFile.length; i++) {
        if (this.itemFile[i].name === file.name) {
          this.worksheet.splice(i, 1)
          this.itemFile.splice(i, 1)
        }
      }
    },
    async basicPartsToSQL() {
      try {
        this.loading = true
        this.err = 0
        for (let j = this.worksheet.length - 1; j >= 0; j--) {
          let name,
            value,
            type,
            descript,
            comments
          for (let i = 0; i < 999; i++) {
            const attr = i + 2
            name = this.worksheet[j][`A${attr}`] ? this.worksheet[j][`A${attr}`].v : ''
            value = this.worksheet[j][`B${attr}`] ? this.worksheet[j][`B${attr}`].v : ''
            type = this.worksheet[j][`C${attr}`] ? this.worksheet[j][`C${attr}`].v : ''
            descript = this.worksheet[j][`D${attr}`] ? this.worksheet[j][`D${attr}`].v : ''
            comments = this.worksheet[j][`E${attr}`] ? this.worksheet[j][`E${attr}`].v : ''
            console.log(name, value, type, descript, comments)
            if (!name) {
              break
            } else {
              if (name) {
                await sleep(50)
                await this.insertToSQL(name, value, type, descript, comments)
              } else {
                this.loading = false
                this.disabled = false
                return
              }
            }
          }
          this.itemFile.splice(j, 1)
          this.worksheet.splice(j, 1)
          this.err === 0 ? this.$message.success(`导入完成`) : this.$message.error(`导入失败个数为${this.err}，请检查文件是否正确`)
        }
        this.loading = false
        this.searchTable()
      } catch (e) {
        this.err++
        this.loading = false
        this.$notify.error(`导入数据错误,请检查导入文件是否正确`)
        console.log(`导入数据错误${e}`)
      }
    },
    async insertToSQL(name, value, type, descript, comments) {
      try {
        var param = []
        param[0] = ['name', name]
        param[1] = ['value', value]
        param[2] = ['type', type]
        param[3] = ['descript', descript]
        param[4] = ['comments', comments]
        var Data = this.CreateData('12', 'Recipe_WorkBook_Excel', param)
        const response = await this.ExecDatabase(Data)
        if (response.data[0].result === '1') {
          this.$notify.success(`${name}导入成功`)
        } else {
          this.$notify.error(`${name}导入失败`)
        }
      } catch (e) {
        this.err++
        this.$message.error(`导入数据错误`)
        console.log(`导入数据错误${e}`)
      }
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.pageCurrent = 1
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    }
  }
}
</script>

<style scoped>
</style>

